[PATCH mtd-utils 03/11] tests: ubifs_repair: Add cycle mount+repair test

From: Zhihao Cheng
Date: Wed Dec 27 2023 - 20:34:07 EST


Do fsstress and repair ubifs image, make sure all files(and their data)
are not lost after repairing. This testcase mainly checks whether
ubifs_repair could corrupt filesystem content in common case.

Signed-off-by: Zhihao Cheng <chengzhihao1@xxxxxxxxxx>
---
.gitignore | 1 +
configure.ac | 3 +-
tests/ubifs_repair-tests/Makemodule.am | 3 +-
.../tests/cycle_mount_repair_check.sh.in | 177 +++++++++++++++++++++
4 files changed, 182 insertions(+), 2 deletions(-)
create mode 100755 tests/ubifs_repair-tests/tests/cycle_mount_repair_check.sh.in

diff --git a/.gitignore b/.gitignore
index 7613349..1a5fe7e 100644
--- a/.gitignore
+++ b/.gitignore
@@ -114,6 +114,7 @@ tests/ubi-tests/runubitests.sh
tests/ubi-tests/ubi-stress-test.sh
tests/ubifs_repair-tests/lib/common.sh
tests/ubifs_repair-tests/tests/authentication_refuse.sh
+tests/ubifs_repair-tests/tests/cycle_mount_repair_check.sh

#
# Files generated by autotools
diff --git a/configure.ac b/configure.ac
index a42a55d..73a3853 100644
--- a/configure.ac
+++ b/configure.ac
@@ -356,6 +356,7 @@ AC_CONFIG_FILES([tests/fs-tests/fs_help_all.sh
tests/ubi-tests/runubitests.sh
tests/ubi-tests/ubi-stress-test.sh
tests/ubifs_repair-tests/lib/common.sh
- tests/ubifs_repair-tests/tests/authentication_refuse.sh])
+ tests/ubifs_repair-tests/tests/authentication_refuse.sh
+ tests/ubifs_repair-tests/tests/cycle_mount_repair_check.sh])

AC_OUTPUT([Makefile])
diff --git a/tests/ubifs_repair-tests/Makemodule.am b/tests/ubifs_repair-tests/Makemodule.am
index c0a6ea1..c2556f5 100644
--- a/tests/ubifs_repair-tests/Makemodule.am
+++ b/tests/ubifs_repair-tests/Makemodule.am
@@ -1,3 +1,4 @@
test_SCRIPTS += \
tests/ubifs_repair-tests/lib/common.sh \
- tests/ubifs_repair-tests/tests/authentication_refuse.sh
+ tests/ubifs_repair-tests/tests/authentication_refuse.sh \
+ tests/ubifs_repair-tests/tests/cycle_mount_repair_check.sh
diff --git a/tests/ubifs_repair-tests/tests/cycle_mount_repair_check.sh.in b/tests/ubifs_repair-tests/tests/cycle_mount_repair_check.sh.in
new file mode 100755
index 0000000..1f5db3f
--- /dev/null
+++ b/tests/ubifs_repair-tests/tests/cycle_mount_repair_check.sh.in
@@ -0,0 +1,177 @@
+#!/bin/sh
+# Copyright (c), 2023-2024, Huawei Technologies Co, Ltd.
+# Author: Zhihao Cheng <chengzhihao1@xxxxxxxxxx>
+#
+# Test Description:
+# Do many cycles of mount/fsstress/umount/repair/mount, check whether filesystem
+# content before repairing and after repairing are consistent.
+# Running time: 16h
+
+TESTBINDIR=@TESTBINDIR@
+source $TESTBINDIR/common.sh
+
+# No need to test on large size flash, it will take very long time iterating
+# all files in large filesystem.
+ID="0xec,0xa1,0x00,0x15" # 128M 128KB 2KB 512-sub-page
+
+function run_test()
+{
+ mode=$1
+ encryption=$2
+ modprobe nandsim id_bytes=$ID
+ mtdnum="$(find_mtd_device "$nandsim_patt")"
+ flash_eraseall /dev/mtd$mtdnum
+
+ dmesg -c > /dev/null
+
+ modprobe ubi mtd="$mtdnum,2048,0,0,1" fm_autoconvert || fatal "modprobe ubi fail"
+ ubimkvol -N vol_test -m -n 0 /dev/ubi$UBI_NUM || fatal "mkvol fail"
+ modprobe ubifs || fatal "modprobe ubifs fail"
+
+ echo "Do cycle mount+umount+repair+check_fs_content test ($encryption,$mode)"
+
+ if [[ "$encryption" == "encrypted" ]]; then
+ encryption_gen_key
+ fi
+
+ round=0
+ while [[ $round -lt 20 ]]
+ do
+ echo "---------------------- ROUND $round ----------------------"
+ let round=$round+1
+
+ mount_ubifs $DEV $MNT || fatal "mount ubifs fail"
+ if [[ "$encryption" == "encrypted" ]]; then
+ encryption_set_key $MNT
+ fi
+
+ per=`df -Th | grep ubifs | awk '{print $6}'`;
+ if [[ ${per%?} -gt 95 ]]; then
+ # Used > 95%
+ echo "Clean files"
+ rm -rf $MNT/*
+ check_err_msg
+ fi
+
+ # Truncation and writing ops cannot coexist, because ubifs_repair could recover truncated data nodes which leads different md5 results before repairing and after repairing. For example:
+ # 1. write(file, 8K)
+ # 2. truncate(file, 0) # data block 0,1 are truncated
+ # 3. lseek(file, 4K)
+ # 4. write(file, 4K) # data block 1' is created
+ # 5. truncate(file, 8000) # data block 1'' is modified
+ # It is expected that only data block 1'' is found after repairing, but ubifs_repair will try best to recover all nodes(ubifs_repair cannot utilize TNC information), so data block 0 and data block 1'' are found.
+ if [[ "$mode" == "notruncate" ]]
+ then
+ fsstress -d $MNT -l0 -p4 -n10000 -f truncate=0 &
+ elif [[ "$mode" == "nowrite" ]]
+ then
+ fsstress -d $MNT -l0 -p4 -n10000 -f dwrite=0 -f awrite=0 -f write=0 -f writev=0 -f mwrite=0 -f uring_write=0 -f copyrange=0 -f deduperange=0 -f clonerange=0 -f splice=0 &
+ else
+ fsstress -d $MNT -l0 -p4 -n10000 &
+ fi
+
+ sleep $((RANDOM % 30))
+
+ ps -e | grep -w fsstress > /dev/null 2>&1
+ while [ $? -eq 0 ]
+ do
+ killall -9 fsstress > /dev/null 2>&1
+ sleep 1
+ ps -e | grep -w fsstress > /dev/null 2>&1
+ done
+
+ check_err_msg # Make sure new operations are okay after repairing UBIFS
+ sync
+
+ # Record filesystem information
+ rm -f $TMP_FILE 2>/dev/null
+ if [[ "$mode" == "all" ]]
+ then
+ read_dir $MNT "nomd5sum"
+ else
+ read_dir $MNT "md5sum"
+ fi
+
+ while true
+ do
+ res=`mount | grep "$MNT"`
+ if [[ "$res" == "" ]]
+ then
+ break;
+ fi
+ umount $MNT
+ sleep 0.1
+ done
+
+ echo 'format "UBIFS DBG repair" +pflmt' > /sys/kernel/debug/dynamic_debug/control
+ echo "$DEV" > /sys/kernel/debug/ubifs/repair_fs
+ res=$?
+ if [[ $res != 0 ]]
+ then
+ fatal "repair fail $res"
+ fi
+
+ # There are no powercut or corruption, error messages won't appear in UBIFS repairing
+ check_err_msg
+
+ check_memleak
+
+ enable_chkfs
+
+ mount_ubifs $DEV $MNT
+ res=$?
+ if [[ $res != 0 ]]
+ then
+ fatal "mount fail $res"
+ fi
+
+ if [[ "$encryption" == "encrypted" ]]; then
+ encryption_set_key $MNT
+ fi
+
+ du -sh $MNT > /dev/null # Make sure all files are accessible
+ ret=$?
+ if [[ $ret != 0 ]]; then
+ fatal "Cannot access all files"
+ fi
+ check_err_msg
+
+ # Check filesystem information
+ if [[ "$mode" == "all" ]]
+ then
+ parse_dir "nomd5sum"
+ else
+ parse_dir "md5sum"
+ fi
+ rm -f $TMP_FILE 2>/dev/null
+
+ umount $MNT
+ res=$?
+ if [[ $res != 0 ]]
+ then
+ fatal "unmount fail $res"
+ fi
+
+ check_err_msg
+
+ disable_chkfs
+ done
+
+ modprobe -r ubifs
+ modprobe -r ubi
+ modprobe -r nandsim
+}
+
+check_fsstress
+start_t=$(date +%s)
+for encryption in "encrypted" "noencrypted"; do
+ # This situation is ignored, fsstress (comes from https://git.kernel.org/pub/scm/fs/xfs/xfstests-dev.git) could invoke open(O_TRUNC), however there is no 'O_TRUNC' passed into open syscall after looking through the code, so we just skip this case for now.
+ #run_test "notruncate" $encryption
+
+ run_test "nowrite" $encryption
+ run_test "all" $encryption
+done
+end_t=$(date +%s)
+time_cost=$(( end_t - start_t ))
+echo "Success, cost $time_cost seconds"
+exit 0
--
2.13.6